local _G = GLOBAL
local APPI = AddPrefabPostInit

local KIDNAP = _G.Action{}
KIDNAP.str = "Kidnap"
KIDNAP.id = "KIDNAP"
KIDNAP.priority = 2

KIDNAP.fn = function(act)
	if act.target and act.target.components.kidnappable 
	and act.invobject and act.invobject.components.kidnapping then 
		return act.target.components.kidnappable:Kidnap(act.doer, act.invobject)
	end 
end

AddAction(KIDNAP)
AddStategraphActionHandler("wilson", _G.ActionHandler(_G.ACTIONS.KIDNAP, "dolongaction"))

APPI("rope", function(inst)
	inst:AddComponent"kidnapping"
end)

AddPrefabPostInitAny(function(inst)
	if not inst.components.inventoryitem 
		and inst.components.locomotor 
		and inst.components.sleeper
		and inst.components.health
	then 
		inst:AddComponent"kidnappable"
	end 	
end)

APPI("bundle", function(inst)
	local OnLoad, OnSave = inst.OnLoad, inst.OnSave
	
	inst.OnLoad = function(inst, data)
		if data and data.hostage then inst:SetHostage(data.hostage) end 
		if OnLoad then return OnLoad(inst, data) end 
	end
	
	inst.OnSave = function(inst, data)
		if inst.hostage then data.hostage = inst.hostage end 
		if OnSave then return OnSave(inst, data) end 
	end
	
	inst.SetHostage = function(inst, name)
		inst.hostage = name
		inst.name = --[["Kidnapped " .. ]]name
	end
	
	local unwrappable = inst.components.unwrappable
	local onunwrappedfn = unwrappable.onunwrappedfn
	unwrappable.onunwrappedfn = function(inst, point, doer, ...)
		if not inst.hostage or inst.burnt then 
			return onunwrappedfn(inst, point, doer, ...) 
		end 
		
		if doer and doer.SoundEmitter then 
			doer.SoundEmitter:PlaySound"dontstarve/common/together/packaged"
		end 
		
		inst:Remove()
	end
end)
-- indecision as to whether a rope should suffice or wheter it should require a bundling wrap