local Kidnappable = Class(function(self, inst)
	self.inst = inst
end)

function Kidnappable:CanKidnap()
	local inst = self.inst
	local health = inst.components.health
	
	if inst.components.sleeper and inst.components.sleeper:IsAsleep() then 
		return true
	elseif health then 
		return health:GetPercent() <= 0.5 and health.currenthealth <= 25
	else 
		return true
	end 
end 

function Kidnappable:Kidnap(doer, item)
	if not doer then return end 
	local inst = self.inst

	if not self:CanKidnap() then 
		inst:PushEvent("attacked", {attacker = doer, damage = 0})
		return false 
	end 
	
	inst:PushEvent("attacked", {attacker = doer, damage = 0})
	
	if not inst.components.inventoryitem then inst:AddComponent"inventoryitem" end 
	local bundle = SpawnPrefab"bundle"
	bundle.components.unwrappable:WrapItems({inst}, doer)
	bundle:SetHostage(inst.name)
	inst:Remove()
	
	if not item then 
	elseif item.components.stackable then 
		item.components.stackable:Get():Remove()
	else
		item:Remove() 
	end 
	
	if not doer.components.inventory or not doer.components.inventory:GiveItem(bundle) then 
		bundle.Transform:SetPosition(doer.Transform:GetWorldPosition())
	end 
	
	return true
end

return Kidnappable